Use basegfx::rad2deg() instead of *57.29577951308
[LibreOffice.git] / bin / check-elf-dynamic-objects
blob523a892e42595dc4d5e824f1a223d69589b76e44
1 #!/usr/bin/env bash
3 # This file is part of the LibreOffice project.
5 # This Source Code Form is subject to the terms of the Mozilla Public
6 # License, v. 2.0. If a copy of the MPL was not distributed with this
7 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
10 # verify that ELF NEEDED entries are known-good so hopefully builds run on
11 # lots of different GNU/Linux distributions
13 set -euo pipefail
15 PARA=1
16 check_path="${INSTDIR:-.}"
18 help()
20 cat << "EOF"
21 -d <dir> directory to check
22 -p run unbound parallel checks
23 -h help
24 EOF
25 [ -z "${1:-}" ] && exit 0
28 die()
30 echo "$1"
31 echo
32 help 1
33 exit 1
36 while [ "${1:-}" != "" ]; do
37 parm=${1%%=*}
38 arg=${1#*=}
39 has_arg=
40 if [ "${1}" != "${parm?}" ] ; then
41 has_arg=1
42 else
43 arg=""
46 case "${parm}" in
47 --dir|-d)
48 if [ "$has_arg" ] ; then
49 check_path="$arg"
50 else
51 shift
52 check_path="$1"
54 if [ ! -d "$check_path" ]; then
55 die "Invalid directory '$check_path'"
58 -h)
59 help
61 -p)
62 # this sounds counter intuitive but the idea
63 # is to possibly support -p <n>
64 # in the meantime: 0 = nolimit and -p 1 would mean
65 # the current default: serialize
66 PARA=0
68 -*)
69 die "Invalid option $1"
72 if [ "$DO_NEW" = 1 ] ; then
73 REPO="$1"
74 else
75 die "Invalid argument $1"
78 esac
79 shift
80 done
83 files=$(find "${check_path}/program" "${check_path}/sdk/bin" -type f)
84 # all RPATHs should point to ${INSTDIR}/program so that's the files they find
85 programfiles=$(echo ${files} | grep -o '/program/[^/]* ' | xargs -n 1 basename)
87 # allowlists should contain only system libraries that have a good reputation
88 # of maintaining ABI stability
89 # allow extending the allowlist using the environment variable to be able to work
90 # on the installer stuff without the need for a baseline setup
91 globalallowlist="ld-linux-x86-64.so.2 ld-linux.so.2 libc.so.6 libm.so.6 libdl.so.2 libpthread.so.0 librt.so.1 libutil.so.1 libnsl.so.1 libcrypt.so.1 libgcc_s.so.1 libstdc++.so.6 libz.so.1 libfontconfig.so.1 libfreetype.so.6 libxml2.so.2 libxslt.so.1 libexslt.so.0 ${LO_ELFCHECK_ALLOWLIST-}"
92 x11allowlist="libX11.so.6 libX11-xcb.so.1 libXext.so.6 libSM.so.6 libICE.so.6 libXinerama.so.1 libXrender.so.1 libXrandr.so.2 libcairo.so.2"
93 openglallowlist="libGL.so.1"
94 gobjectallowlist="libgobject-2.0.so.0 libglib-2.0.so.0"
95 gdbusallowlist="libdbus-glib-1.so.2 libdbus-1.so.3 libgmodule-2.0.so.0 libgthread-2.0.so.0 ${gobjectallowlist}"
96 gioallowlist="libgio-2.0.so.0 ${gdbusallowlist}"
97 gstreamerallowlist="libgsttag-1.0.so.0 libgstaudio-1.0.so.0 libgstpbutils-1.0.so.0 libgstvideo-1.0.so.0 libgstbase-1.0.so.0 libgstreamer-1.0.so.0 ${gobjectallowlist}"
98 gtk3allowlist="libgtk-3.so.0 libgdk-3.so.0 libcairo-gobject.so.2 libpangocairo-1.0.so.0 libfribidi.so.0 libatk-1.0.so.0 libcairo.so.2 libpangoft2-1.0.so.0 libpango-1.0.so.0 libfontconfig.so.1 libfreetype.so.6 libgdk_pixbuf-2.0.so.0 libharfbuzz.so.0 ${gioallowlist}"
99 qt5allowlist="libQt5Core.so.5 libQt5Gui.so.5 libQt5Network.so.5 libQt5Widgets.so.5 libQt5X11Extras.so.5 libcairo.so.2 libxcb.so.1 libxcb-icccm.so.4 ${gobjectallowlist}"
100 kf5allowlist="libKF5ConfigCore.so.5 libKF5CoreAddons.so.5 libKF5I18n.so.5 libKF5KIOCore.so.5 libKF5KIOFileWidgets.so.5 libKF5KIOWidgets.so.5 libKF5WindowSystem.so.5"
101 avahiallowlist="libavahi-common.so.3 libavahi-client.so.3 ${gdbusallowlist}"
102 kerberosallowlist="libgssapi_krb5.so.2 libcom_err.so.2 libkrb5.so.3"
103 dconfallowlist="libdconf.so.1 libgio-2.0.so.0 ${gobjectallowlist}"
105 check_one_file()
107 local file="$1"
109 skip=0
110 allowlist="${globalallowlist}"
111 case "${file}" in
112 */sdk/docs/*)
113 # skip the majority of files, no ELF binaries here
114 skip=1
116 */_uuid.cpython-*.so)
117 allowlist="${allowlist} libuuid.so.1"
119 */libcairo.so.2)
120 allowlist="${allowlist} ${x11allowlist} libxcb-shm.so.0 libxcb.so.1 libxcb-render.so.0"
122 */libcairocanvaslo.so)
123 allowlist="${allowlist} libcairo.so.2"
125 */libucpgio1lo.so|*/liblosessioninstalllo.so|*/libevoablo.so)
126 allowlist="${allowlist} ${gioallowlist}"
128 */libavmediagst.so)
129 allowlist="${allowlist} ${gstreamerallowlist}"
131 */libvclplug_kf5lo.so|*/libkf5be1lo.so)
132 if [ "$ENABLE_KF5" = TRUE ]; then
133 allowlist="${allowlist} ${qt5allowlist} ${kf5allowlist}"
136 */libvclplug_gtk3lo.so|*/updater)
137 allowlist="${allowlist} ${x11allowlist} ${gtk3allowlist}"
139 */libvclplug_qt5lo.so)
140 if [ "$ENABLE_QT5" = TRUE ]; then
141 allowlist="${allowlist} ${qt5allowlist}"
144 */libvclplug_gtk3_kde5lo.so)
145 if [ "$ENABLE_GTK3_KDE5" = TRUE ]; then
146 allowlist="${allowlist} ${x11allowlist} ${gtk3allowlist} ${qt5allowlist} ${kf5allowlist}"
149 */lo_kde5filepicker)
150 if [ "$ENABLE_GTK3_KDE5" = TRUE ]; then
151 allowlist="${allowlist} ${x11allowlist} ${gtk3allowlist} ${qt5allowlist} \
152 ${kf5allowlist}"
155 */libdesktop_detectorlo.so|*/ui-previewer|*/oosplash|*/gengal.bin)
156 allowlist="${allowlist} ${x11allowlist}"
158 */libvclplug_genlo.so|*/libchartcorelo.so|*/libavmediaogl.so|*/libOGLTranslo.so|*/liboglcanvaslo.so)
159 allowlist="${allowlist} ${x11allowlist} ${openglallowlist}"
161 */libvcllo.so)
162 allowlist="${allowlist} ${x11allowlist} ${openglallowlist} ${gioallowlist} libcups.so.2"
164 */libsofficeapp.so)
165 allowlist="${allowlist} ${x11allowlist} ${openglallowlist} ${gioallowlist} libcups.so.2"
167 */liblibreofficekitgtk.so)
168 allowlist="${allowlist} ${gtk3allowlist}"
170 */libsdlo.so)
171 allowlist="${allowlist} ${avahiallowlist}"
173 */libskialo.so)
174 allowlist="${allowlist} ${openglallowlist} ${x11allowlist}"
176 */libofficebean.so)
177 allowlist="${allowlist} libjawt.so"
179 */libpostgresql-sdbc-impllo.so)
180 allowlist="${allowlist} ${kerberosallowlist}"
182 */libconfigmgrlo.so)
183 if [ "$ENABLE_DCONF" = TRUE ]; then
184 allowlist="${allowlist} ${dconfallowlist}"
187 */libmergedlo.so)
188 allowlist="${allowlist} ${x11allowlist} ${openglallowlist} ${gioallowlist} libcups.so.2 libcairo.so.2"
190 esac
191 if test "${skip}" = 0 && readelf -d "${file}" &> /dev/null ; then
192 rpath=$(readelf -d "${file}" | grep '(\(RPATH\|RUNPATH\))' || true)
193 neededs=$(readelf -d "${file}" | grep '(NEEDED)' | sed -e 's/.*\[\(.*\)\]$/\1/')
194 neededsinternal=
195 for needed in ${neededs}
197 if ! echo ${allowlist} | grep -q -w "${needed}" ; then
198 neededsinternal="${neededsinternal} ${needed}"
199 if ! echo ${programfiles} | grep -q -w "${needed}" ; then
200 echo "${file}" has suspicious NEEDED: "${needed}"
201 status=1
204 done
205 if test -z "${rpath}" ; then
206 case "${file}" in
207 */python-core-*/lib/lib-dynload/*)
208 # python modules don't have RPATH
210 */share/extensions/*)
211 # extension libraries don't have RPATH
214 # no NEEDED from instdir, no RPATH needed
215 if test -n "${neededsinternal}" ; then
216 echo "${file}" has no RPATH
217 status=1
220 esac
221 else
222 case "$file" in
223 */sdk/bin/*)
224 if echo "${rpath}" | grep -q -v '\[\$ORIGIN/../../program\]$' ; then
225 echo "${file}" has unexpected RPATH "${rpath}"
226 status=1
230 if echo "${rpath}" | grep -q -v '\[\$ORIGIN\]$' ; then
231 echo "${file}" has unexpected RPATH "${rpath}"
232 status=1
235 esac
239 status=0
241 if [ "$PARA" = "1" ] ; then
242 for file in ${files}
244 check_one_file $file
245 done
246 else
247 rm -f check_elf.out
248 for file in ${files}
251 check_one_file $file
252 )>> check_elf.out &
253 done
255 wait
257 if [ -s check_elf.out ] ; then
258 cat check_elf.out
259 status=1
261 rm check_elf.out
263 exit ${status}